          SECTION F                                              FILE  EXTRA.F
                      Using FIND.COM, a public domain utility
                      ***************************************

          FIND.COM is a very useful utility which searches for a specified
          string in an ASCII file or files and prints to screen all lines in
          which the string is found. Each line is preceded by a number which
          indicates the position of the file relative to the beginning of the
          file. If FIND is typed at the CP/M prompt, a short help notice is
          displayed.

          The full command line, written at the CP/M prompt is:-

              A> find d:filename.ext Expression
                     v ^            v
          The command line can be written in upper or lower case.
              d: represents the drive to be searched, filename.ext represents
          the full name of the file to be searched and Expression represents
          the string to be searched for. Note that there must no gap at ^ but
          there must be one at v. Typical command lines are :-

           A> find myprog.bas goto......looks for GOTOs in MYPROG.BAS drive A:
           A> FIND *.BAS INPUT......looks for INPUT on all .BAS files,drive A:
           A> find b:*.* darts.com...looks for darts.com on all files drive.B:

              I recommend that, after you have read the notes below, you try
          various command lines with different types of program. Error
          messages are not very helpful, if they appear at all. If the file to
          be searched is not in ASCII format, FIND will not tell you; it will
          just record no findings, so it is well to check a file with an ASCII
          reader such as TYPE or NSWP if in doubt on this score. If you want
          to search a BASIC program be sure to save it in ASCII.
              Similarly it will record no findings if your Expression is not
          typed correctly. If you are pretty sure that the Expression is in
          the file but is not found check your command line Expression or
          modify it.
              Remember that if you need to search a file for a second
          Expression or you want to modify the command line, just press [COPY]
          and the command line will reappear. Could save a lot of typing!!
              To stop a search press [STOP].

          d:    This part of the command line can be left out if the current
          ****  drive is the drive to be searched.

          filename.ext  Wildcards ? and * can be used in the usual way to
          ************  select a series of files if required. ? can represent
          any single letter, so CHAP?.TXT would search files like CHAP1.TXT,
          CHAP2.TXT etc., while CARS.* would search files like CARS.TXT,
          CARS.DTA, CARS.DAT etc. Even if some of the files are not in ASCII
          and therefore cannot be searched, they will be identified on screen
          so the exercise will have told you something.  FIND.COM will name
          each valid file in turn, print out all relevant lines and record the
          number of instances found in each file. When all files have been
          processed, FIND.COM will show the total number of instances found.

          Expression    This must be an ASCII string, and although case is not
          **********    important, spaces and punctuation are; if you ask for
          "keyword" , expressions such as "KEYword"  will be found but
          " keyword "  or 'keyword' , will not because the spacings or
          puctuation differ from the sample. Wildcard ? can be used to
          represent a letter or letters but * is not accepted in Expression.
          Find is not selective, and if asked to find REM will also offer
          remark, premise etc. T?ne would find words like tone, stone,
          clandestine etc.

          USES OF FIND.COM   Reading through pages and pages of text to find a
          ****************   reference is very frustrating and time consuming.
          There are plenty of tutorials and data files on disc now. Some
          Public Domain Libraries supply their catalogues on disc in files
          with many hundreds of entries. If you want to find reference to a
          program called SQUEEZE, by putting the catalogue disc into drive A:
          and using the command line :-

            A> find *.* squeeze     you might find SQUEEZE.COM, SQUEEZE.DOC,
                                    SQUEEZE.ASM and several others. You will
          certainly find the file or files that contain them and possibly an
          accurate 'fix' on their positions in the files.
              Another use is in helping to unravel programs written in BASIC.
          The program must have been SAVEd in ASCII form. FIND can locate all
          instances of GOTOs, GOSUBs and other keywords to enable easier
          mapping of the path of the program. It can also keep tabs on
          variables.
              Any language that is written or can be saved in ASCII can be
          accessed by FIND. It is of great help with  ASSEMBLY language
          because the programs are often very long, and to be able to find
          specific expressions easily is absolutely invaluable.

          CONCLUSION   FIND.COM is a small program (3k) but very useful. It is
          **********   one of the programs that I copy to the M: drive
          automatically, using a PROFILE.SUB file, when booting CP/M. Then, by
          putting a SETDEF instruction in PROFILE.SUB it is always immediately
          available for use. See file EXTRA.C

          End of file EXTRA.F
ction in PROFILE.SUB it is always immediately
          available for use. See file EXTRA