          SECTION F                                              FILE INTRO.F
                                   USING THE PRINTER
                                   *****************

          NOTE: This text contains notes on ways of using your printer to
          supplement this course but is not a full treatise on the printer.
          For more information see INTER SECTION I.
          ------------------------------------------------------------------
          The printer supplied with your PCW can be a very useful aid to your
          progress with this course. It can make a hard copy of all the files
          on this disc, enabling you if you wish to make up a file for study
          away from the computer. More immediately, it will print out listings
          before you work on them , so that you can make comparisons.

              Each time you start work on the course make sure that your
          printer is supplied with paper. Continuous paper 11"x 9.5"is
          recommended, but A4 sheets can be used if preferred.

              To print out a listing from a BASIC program is very simple. The
          commands used are the same as the LIST commands except that LLIST is
          used as follows
              1) To list a whole program:-  Type LLIST       then press RETURN
              2) To list lines up to 300:-  Type LLIST -300    "    "      "
              3) To list lines 300 onward:- Type LLIST  300-   "    "      "
              4) To list lines 250 to 530:- Type LLIST 250-530 "    "      "
          Needless to say, you must be in direct mode when typing the
          instruction. Line numbers quoted are, of course, simply examples.
          You will use your own line numbers.

          PRINTING TEXT FILES
               The first requirement is to find the file name of the file you
          want. A list of the files on any disc can be seen by typing DIR at
          the prompt either in CP/M or BASIC

              Files with names such as INTRO.A,  PRIMER.C,  INTER.F are text
          files which form part of the section after which they are named,
          files with a .BAS extension are programs in BASIC but are still
          printable as they are in ASCII format. In fact, all files on
          BASTUTOR discs are in ASCII format except for .COM files. For a list
          of files see DISC.CAT on side 1.

              PRINTING OUT FILES IS BEST DONE FROM CP/M, not BASIC and can be
          done in several ways.

           1)  Files can be read on the screen by typing at the CP/M prompt.
          A>TYPE filename.txt   where 'filename.txt',of course, represents the
          name of your required file,then pressing RETURN. The file will be
          displayed for reading one page at a time, with the note ' Press
          return to continue ' at the bottom of each page. To print the file
          on paper the same command is used, but before pressing RETURN, press
          ALT and P together to  activate the printer.The machine will emit a
          beep. On pressing RETURN the printer will commence to print out the
          file, assuming it is loaded with paper. At the end of each page,
          press RETURN  as requested to print out the next page. When you have
          finished with the printer press ALT and P again to deactivate the
          printer or it will continue to print everything you type, which can
          be maddening. ALT and P is a 'toggle'. With a beep,printer on; with
          no beep, printer off.

           2) USING TYPE.COM :  When using the above method, the words 'Press
          RETURN to Continue' will be printed periodically, which looks a bit
          untidy. To get over this we can use the utility TYPE.COM, which is
          to be found on the CP/M master supplied with the machine. Insert tha
          CP/M disc and at the prompt put  A>TYPE and press return. This loads
          TYPE.COM and you will be rewarded with a further prompt:-   File
          Name: At this you type the following;  filename.txt [no page]  (note
          the square brackets) and press ALT and P as before. But before you
          press RETURN change the CP/M disc for your course disc with the
          required file on it. When you press RETURN the file will print
          neatly. However this method does involve swapping discs for each
          file printed, unless you know how to transfer files from disc to
          disc, which is discussed later in this course.

           3) USING PIP.COM : This utility is also to be found on the CP/M
          master disc. With the CP/M disc in the drive type PIP at the A>
          prompt. A short heading will appear with the  character * below it.
          Replace the CP/M disc with the disc containing the file to be
          printed, then type the command line * LST:= A:filename.ext (not
          forgetting the colons) press ALT and P as described before, to
          activate the printer, then press RETURN and your selected file will
          print out. When the file is completely printed, another * will
          appear. Press [COPY] to reinstall your command line, delete the file
          name and replace with another, then press [RETURN] to print that one
          and so on. To return to CP/M press RETURN without a command line.
          This method saves a lot of disc changing. If you want to view a file
          on screen use the similar command line * CON:=A:filename.ext

           4) NSWP.COM : This Public Domain utility, is supplied on side 4,
          complete with documentation in EXTRA, section e). It is, in my
          opinion, the best way to handle files. It can read, print, copy,
          rename and erase files plus much more and is easy to use. I suggest
          that you get to know it as soon as possible.

              ************************************************************

          POKEing BASIC
          =============
          Using the POKE command in BASIC calls up a machine code routine from
          within BASIC, and there is a routine for using the printer. To start
          it go into Direct Mode in BASIC then type at the prompt :-
                   POKE 8792, 205   and press [RETURN]. Thereafter anything
          which appears on screen will be echoed by the printer, so you can
          call up files with TYPE or DISPLAY and they will printed out.
          Unfortunately you cannot be selective, and everything which is on
          the screen will print. To stop this facility type at the prompt:-
                   POKE 8792,195  and press [RETURN]. These commands can be
          used in a BASIC listing also and can be used to capture a program or
          parts of a program as it runs
              All of the above methods have their own merits. Try them all to
          find out which you prefer

          SCREEN DUMP
          ===========
          A copy of what is being displayed on screen at any time can be
          obtained, although to a smaller scale by pressing keys [EXTRA] and
          [PTR] together.

          End of file INTRO.F
btained, although to a smaller s