7 REM ********************************
8 REM **           TUTOR V1.2          **
9 REM ********************************
10 cls$=CHR$(27)+"E"+CHR$(27)+"H": REM clear screen & home cursor
20 rvson$=CHR$(27)+"p": REM reverse video on
30 rvsoff$=CHR$(27)+"q": REM reverse video off
40 DEF FN posn$(x,y)=CHR$(27)+"Y"+CHR$(32+y)+CHR$(32+x): REM position cursor
50 PRINT CHR$(27)+"0": REM Cuts out the notice "Drive is A"; (PCW8256 only)                                      Had you noticed?  to get it back type PRINT CHR$(27)+"1"
60 REM ***********************************************************
70 REM * to return to PRIMER type GOTO 16400 then press [RETURN] *
80 REM ***********************************************************
90 PRINT cls$: REM See line 10. 
100 PRINT FN posn$(34,2) " B A S T U T O R "
110 PRINT FN posn$(8,4) " A disc-based tutorial about MALLARD BASIC for the PCW8256 & PCW8512"
120 PRINT FN posn$(29,6)" Copyright Ron King 1990"
130 PRINT FN posn$(20,9)" a) INTRO          - Introductory text -    Side 1"
140 PRINT FN posn$(20,11)" b) PRIMER         - First steps       -    Side 1 "
150 PRINT FN posn$(20,13)" c) INTER          - Intermediate      -    Side 2 "
160 PRINT FN posn$(20,15)" d) MORE           - Text files        -    Side 3 " 
170 PRINT FN posn$(20,17)" e) EXTRA          - Miscellaneous     -    Side 4 " 
180 PRINT FN posn$(20,20)" f) Return to DIRECT MODE in BASIC "
190 PRINT FN posn$(20,22)" g) Return to CP/M "            
200 PRINT rvson$ FN posn$(8,25) SPC(67) rvsoff$
210 PRINT rvson$ FN posn$(8,26)"  Please enter the letter of the section you require, then RETURN  " rvsoff$
220 INPUT n$
230 n$=UPPER$(n$)
240 code=INSTR(1,"ABCDEFG",n$)
250 IF code=0 THEN PRINT " Enter a letter a-g; please try again; Press any key to continue ": WHILE INKEY$="":WEND:GOTO 90
260 ON code GOTO 300,310,320,330,340,350,360
300 file$="INTRO.BAS"
305 IF FIND$(file$)="" THEN 600 ELSE 450
310 file$="PRIMER.BAS"
315 IF FIND$(file$)="" THEN 600 ELSE 460
320 file$="INTMENU.BAS"
325 IF FIND$(file$)="" THEN 600 ELSE 470
330 file$="MORE.BAS"
335 IF FIND$(file$)="" THEN 600 ELSE 480
340 file$="EXTRA.BAS"
345 IF FIND$(file$)="" THEN 600 ELSE 490
350  PRINT " You are now in DIRECT MODE; to return to program type RUN then press RETURN": END
360 INPUT " RETURN TO CP/M ; Are you sure ?  y/n   ", y$
370 IF y$="y" OR y$="Y" THEN SYSTEM ELSE GOTO 90
450 IF filename$ = "INTRO" THEN 2000 ELSE 500
460 IF filename$ = "PRIMER" THEN 2000 ELSE 510
470 IF filename$ = "INTMENU" THEN 2000 ELSE 520
480 IF filename$ = "MORE" THEN 2000 ELSE 530
490 IF filename$ = "EXTRA" THEN 2000 ELSE 540
500 GOSUB 40300: CHAIN MERGE "INTRO",2000,ALL,DELETE 2000-30000:END
510 GOSUB 40300: CHAIN MERGE "PRIMER",2000,ALL,DELETE 2000-30000:END
520 GOSUB 40300: CHAIN MERGE "INTMENU",2000,ALL,DELETE 2000-30000:END
530 GOSUB 40300: CHAIN MERGE "MORE",2000,ALL,DELETE 2000-30000:END
540 GOSUB 40300: CHAIN MERGE "EXTRA",2000,ALL,DELETE 2000-30000:END
600  PRINT "The section you want is not on this side; Put the side shown on the menu into the A: drive and try again - press any key to continue ": WHILE INKEY$="": WEND:  
610 INPUT " Do you want to ... 1) Continue   2) Return to menu....... ",    n 
620 IF n<1 OR n>2 THEN PRINT " Type 1 or 2 please ": GOTO 610
630 IF n=1 THEN 260 ELSE 90
39990 END
40000 REM ++++++ Subroutine for EDITING LINE NOTICE ++++++
40010 PRINT"To experiment with the program, first press STOP to enter DIRECT MODE"
40020 PRINT "Type EDIT nnnn ( where nnnn is the line number of your choice) then press RETURN"
40030 PRINT "  This prints the line in EDIT MODE and  allows it to be altered " : PRINT
40040 RETURN
40050 REM ++++ SUBROUTINE for TEXT WARNING +++
40060 PRINT TAB(14)"Text follows. Get ready to control it with the f5 Key "
40070 PRINT TAB(15)" ***** Press RETURN when ready to continue *****
40080 WHILE INKEY$<>CHR$(13):WEND
40090 RETURN
40100 REM ++++ SUBROUTINE ++++ 
40110 PRINT "Press RETURN to continue": WHILE INKEY$<>CHR$(13):WEND:RETURN 
40120 PRINT "Press RETURN to return to games menu":WHILE INKEY$<>CHR$(13):WEND:RETURN
40130 PRINT "Press RETURN to continue to next section ": WHILE INKEY$<>CHR$(13):WEND:RETURN 
40150 REM ++++ SUBROUTINE for section menu ++++
40160 PRINT:PRINT TAB(10) rvson$ " Type C to continue / R to reread the last text / M for section Menu " rvsoff$
40170 answer$=INKEY$ 
40180 IF answer$ = "" THEN 40170
40190 code = INSTR(1,"cCrRmM",answer$)
40200 IF code = 0 THEN GOTO 40160
40210 RETURN
40300 PRINT rvson$ " LOADING - Please wait " rvsoff$:RETURN
CrRm